/*_____________________________________________________________________________________________________________________________________________________________________
SNS_TABLE_OBJECT.mqh SNS_ObjectLibrary.mqhSteven N. Scott

NOTE: THIS IS AN #INCLUDE FILE AND  NEEDS TO BE IN YOUR EXPERT\INCLUDES FOLDER.
_______________________________________________________________________________________________________________________________________________________________________*/
#property copyright "Steven N. Scott"
#property link      ""

// IMPORT LIBRARY OF SNSCOTT'S COMMON FUNCTIONS AND UTILITIES============================================================================================================
// v2.0

#import "SNS_ObjectLibrary.ex4"

	// GENRERAL UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	string	SNSLibrary.Version();
	void 		SNSTAG();
	void 		DeleteObjectsByPrefix(string Prefix);
	bool   	IsMini();
	bool   	IsDoubleDotted();
	bool   	IsDotted();	

	// GRAPHIC OBJECT UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------
   void 		Draw_HLine(string prefix, string name, int style, int width, color clr, datetime x, double y, bool back, int window=0);
   void 		Draw_VLine(string prefix, string name, int style, int width, color clr, datetime x,  bool back, int window=0);
   void 		Draw_TLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_LabeledLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, string label, string font, int fontsize, color fontcolor,datetime labelx, double labely, int window=0);
	void 		Draw_Box(string prefix, string name, color boxcolor, datetime x1, double y1, datetime x2, double y2, bool back, int linewidth, int linestyle, int window=0);
   void 		Draw_Fibo(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_FiboChannel(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, datetime x3, double y3, bool ray, bool back, int window=0);
   void 		Draw_Text(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_VText(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Label(string prefix, string name, string text, int corner, int x, int y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Symbol(string prefix, string name, int code, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_Arrow(string prefix, string name, string dir, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_PriceBox(string prefix, string name, bool left, int width, color colour, datetime x, double y, bool back, int window=0);
   
   // TIME UTILITIES----------------------------------------------------------------------------------------------------------------------------------------------------
	datetime Time.AddPeriod(datetime dt, int period, int inc);
	datetime Time.AddMinutes(datetime dt, int minutes);
	datetime Time.AddHours(datetime dt, int hours);
	datetime Time.AddDays(datetime dt, int days);
	datetime Time.Add(datetime dt, int inc);

	string 	Time.MDYHMSToStr(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec);
	string 	Time.DateTimeToStr(datetime dt); 
	string	Time.ToFormatStr(datetime dt, string format);	
	string 	Time.TFToString(int tf);
	string 	Time.FrameUnit(int tf);
	int 		Time.Encompassing(string tf);
	string	Time.DOW(int d);
	
	// STRING UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	int 		String.ToTimeFrame(string tf);
	string 	String.Repeat(string str, int n);
	string 	String.UpperCase(string str);
	string 	String.LowerCase(string str);
	string 	String.LeftPad(string str, int n, string str2);
	string 	String.RightPad(string str, int n, string str2);
	string 	String.Left(string str, int n);
	string 	String.Right(string str, int n);
	int 		String.ToArray(string& array[], string source);
	int 		String.ToUCArray(string& array[], string source);
	int 		String.ToLCArray(string& array[], string source);
	int 		String.ToIntArray(int& array[],string source);
	int 		String.ToDoubleArray(double& array[],string source);
	string 	String.Trim(string str);		
	string 	String.RightAlign( string rString, int ra );
	int 		String.ToColor(string str);
	string 	Price.AbrvToName(string p);
	string 	Price.Abrv(string p);
	
	// OBJECT UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	string 	Object.UniqueName(string prefix, string rest);

	// REVERSAL UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	color		Rev.GetColor(color defaultColor, bool SetIfMissing);
	color		Rev.SetColor(color RevColor);
	bool 		Rev.ColorChanged(color PreviousColor);
	int 		Rev.Status(string myPair, int TimeFrame, double Threshold, bool ShortTrader, bool LongTrader );
	
#import
///\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\

